//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#pragma hdrstop
//---------------------------------------------------------------------------
#include <vcl.h>
#include "Unit1.h"
#include <time.h>
//---------------------------------------------------------------------------
TForm1 *Form1;
//---------------------------------------------------------------------------
// 
__fastcall TForm1::TForm1(TComponent* Owner) : TForm(Owner)
{
 int h = ImageList1->Height;
 for (int i=0;i<m;i++)    //  
  for (int j=0;j<n;j++) {
   field[i][j] = new cage(Form1,ImageList1,j*h,i*h+20); // 
                                                        // cage
   field[i][j]->Tag = i*m+j;          //   
   field[i][j]->OnClick = CageClick;  //    OnClick
  };
}
//---------------------------------------------------------------------------
bool TForm1::AddFig() { //    
 if (fcount < kf) {     //   ,   
  for (int i=0;i<m;i++) //    
   for (int j=0;j<n;j++)
    if (field[i][j]->stat == 0)
     field[i][j]->stat = random(ImageList1->Count-1)+1;
 }
 else {                    //
  for (int k=0;k<kf;k++) { //   kf   
   int i,j;
   do {
    i = random(m);
    j = random(n);
   } while (field[i][j]->stat !=0);
   field[i][j]->stat = random(ImageList1->Count-1)+1;
  };
 };
 fcount -= kf;          //   
 if (fcount <= 0)       //  
  return false;         // 
 else                   //
  return true;          // 
};
//---------------------------------------------------------------------------
//  OnCreate 
void __fastcall TForm1::FormCreate(TObject *Sender)
{
 randomize();  //   
 NewGame();    //  
}
//---------------------------------------------------------------------------
//  OnDestroy 
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
 for (int i=0;i<m;i++)   // ,    
  for (int j =0;j<n;j++)
   delete field[i][j];
}
//---------------------------------------------------------------------------
//     (is,js)   (ie,je)
bool TForm1::FindWay(int is,int js,int ie,int je) {

 for (int i=0;i<m*n;i++)  //   
  waym[i] = -1;

 for (int i=0;i<m;i++)    //  
  for (int j =0;j<n;j++)
   if (field[i][j]->stat != 0)
    map[i][j] = -1;
   else map[i][j] = 0;

 map[is][js] = 0;        //     
 map[ie][je] = 1;

 bool est;               //  map
 int k = 1;
 do {
  est  = false;
  for (int i=0;i<m;i++)
   for (int j=0;j<n;j++)
    if (map[i][j] == k) {
     est = true;
     for (int np=0;np<4;np++) {
      int in = i+ip[np];
      int jn = j+jp[np];
      if ((in >= 0) && (in < m) && (jn >= 0) && (jn < n))
       if (map[in][jn] == 0)
        map[in][jn] = k + 1;
     };
    }
  k++;
 } while (est);


 wayl = 0;                   // 
 int i = is;int j = js;
 do {
  int im = -1;int jm = -1;
  int np = 0;int c = map[i][j];
  do {
   int in = i+ip[np];
   int jn = j+jp[np];
   if ((in >= 0) && (in < m) && (jn >= 0) && (jn < n))
    if (map[in][jn] > 0)
     if (map[in][jn]<c) {
      c = map[in][jn];
      im = in;jm = jn;
      waym[wayl] = np;
     }
  } while (++np < 4);
  i = im;j = jm;wayl++;
 } while ((i>=0) && (j >=0));

 if (wayl > 1)      //  
  return true;      // 
 else               //
  return false;     // 
};
//---------------------------------------------------------------------------
//  (is,js)     
void TForm1::Go(int is,int js) {
 int i = is,j = js;
 for (int k=0;k<wayl-1;k++) {
  int in = i + ip[waym[k]];
  int jn = j + jp[waym[k]];
  int t = field[i][j]->stat;
  field[i][j]->stat = 0;
  field[in][jn]->stat = t;
  i = in;j = jn;
  Application->ProcessMessages();
  Sleep(50);
 };
};
//---------------------------------------------------------------------------
// l ,   (is,js)   np
void TForm1::ClearCages(int is,int js,int np,int l) {
 int in = is;
 int jn = js;
 for (int i=0;i<l;i++) {
  field[in][jn]->stat = 0;
  in += ip[np];
  jn += jp[np];
  Application->ProcessMessages();
  Sleep(50);
 };
};
//---------------------------------------------------------------------------
//   ,    (is,js)   np 
//  
int TForm1::GetLine(int is,int js,int np) {
 int in = is;
 int jn = js;
 int l = 0;
 while (field[in][jn]->stat == field[is][js]->stat) {
  in += ip[np];
  jn += jp[np];
  l++;
  if (!((in >= 0) && (in < m) && (jn >= 0) && (jn < n)))
   return l;
 } ;
 return l;
};
//---------------------------------------------------------------------------
//          
bool TForm1::TryClear() {
 bool cl = false;
 for (int i=0;i<m;i++)
  for (int j=0;j<n;j++)
   if (field[i][j]->stat !=0)
    for (int np=0;np<8;np++) {
     int l = GetLine(i,j,np);   // 
     if (l >=5 ) {              //   5  
      ClearCages(i,j,np,l);     // 
      fcount += l;              //   
      //  
      Point->Caption = IntToStr(StrToInt(Point->Caption) + l);
      cl = true;
      break;
     };
    };
 return cl;
};
//---------------------------------------------------------------------------
//  OnClick   
void __fastcall TForm1::CageClick(TObject *Sender) {
 cage *This = dynamic_cast<cage *>(Sender);
 int i = This->Tag / m;   //   
 int j = This->Tag - i*m;
 if (!This->select) {            //   
  if (This->stat != 0) {         //     
   if ((seli >=0) && (selj>=0))  //    
    field[seli][selj]->select = false;  //   
   seli = i;selj = j;       // 
   This->select = true;
  }
  else                      // (     )
   if ((seli >=0) && (selj>=0)) { //,    
    field[seli][selj]->select = false;//,  
    if (FindWay(seli,selj,i,j)) { //     (i,j)  (seli,selj)
     Go(seli,selj);               //
     if (!TryClear())             //  
      if (!AddFig()) {            //,     
       GameOver();                // 
       return;
      }
      else                       // (  )
       TryClear();               // 
    }
    seli = -1;selj = -1;
   }
   else                       // (    )
    if (This->stat != 0) {    //     
     seli = i;selj = j;       // 
     This->select = true;
    }
 }
 else {                      // (   )
  seli = -1;selj = -1;       // 
  This->select = false;
 };
};
//---------------------------------------------------------------------------
void TForm1::NewGame() {  //  
 for (int i=0;i<m;i++)    //  
  for (int j=0;j<m;j++)
   field[i][j]->stat = 0;
 fcount = m*n;            //   
 AddFig();                //  kf   
 seli = -1;selj = -1;
 Point->Caption = "0";    //  
};
//---------------------------------------------------------------------------
void TForm1::GameOver() { // 
 //  
 Application->MessageBoxA(" .","   . . .",MB_ICONINFORMATION);
 NewGame();  //  
};
//---------------------------------------------------------------------------
//  OnClick   About
void __fastcall TForm1::AboutClick(TObject *Sender)
{
 //  
 Application->MessageBox(" \nDe}{iS, 2007","  . . .",MB_ICONQUESTION);
}
//---------------------------------------------------------------------------

